package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.AimTemplateAim;
import com.izouma.awesomeadmin.service.AimTemplateAimService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/aimTemplateAim")
public class AimTemplateAimController {

    @Autowired
    private AimTemplateAimService aimTemplateAimService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(AimTemplateAim record) {
        List<AimTemplateAim> pp = aimTemplateAimService.getAimTemplateAimList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getAimTemplateAim", method = RequestMethod.GET)
    @ResponseBody
    public Result getAimTemplateAim(@RequestParam(required = false, value = "id") String id) {
        AimTemplateAim data = aimTemplateAimService.getAimTemplateAimById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(AimTemplateAim record) {
        AimTemplateAim data = aimTemplateAimService.getAimTemplateAim(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, AimTemplateAim record) {
        Map<String, Object> result = new HashMap<>();

        List<AimTemplateAim> pp =aimTemplateAimService.getAimTemplateAimByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(AimTemplateAim record) {
        boolean num = aimTemplateAimService.createAimTemplateAim(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateAimTemplateAim(AimTemplateAim record) {
        boolean num = aimTemplateAimService.updateAimTemplateAim(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteAimTemplateAim(AimTemplateAim record) {

        boolean num = aimTemplateAimService.deleteAimTemplateAim(record);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, AimTemplateAim record) throws Exception {

    List<AimTemplateAim> aimTemplateAims = aimTemplateAimService.getAimTemplateAimList(record);


        String sheetName = "aim_template_aim";
        String titleName = "点标模板点标数据表";
        String fileName = "点标模板点标表";
        int columnNumber = 16;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "点标名称" ,   "图标" ,   "图标顺序" ,   "是否独占" ,   "自动触发" ,   "自动显示" ,   "显示层级" ,   "备注" ,   "上级模板" ,   "权限"  };
        String[][] dataList = new String[aimTemplateAims.size()][16];

        for (int i = 0; i < aimTemplateAims.size(); i++) {

                        dataList[i][0] = String.valueOf(aimTemplateAims.get(i).getId());
                        dataList[i][1] = String.valueOf(aimTemplateAims.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(aimTemplateAims.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(aimTemplateAims.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(aimTemplateAims.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(aimTemplateAims.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(aimTemplateAims.get(i).getAimName());
                        dataList[i][7] = String.valueOf(aimTemplateAims.get(i).getIcon());
                        dataList[i][8] = String.valueOf(aimTemplateAims.get(i).getIconRank());
                        dataList[i][9] = String.valueOf(aimTemplateAims.get(i).getAloneFlag());
                        dataList[i][10] = String.valueOf(aimTemplateAims.get(i).getAutoPlay());
                        dataList[i][11] = String.valueOf(aimTemplateAims.get(i).getAutoDisplay());
                        dataList[i][12] = String.valueOf(aimTemplateAims.get(i).getShowLevel());
                        dataList[i][13] = String.valueOf(aimTemplateAims.get(i).getRemark());
                        dataList[i][14] = String.valueOf(aimTemplateAims.get(i).getTemplateId());
                        dataList[i][15] = String.valueOf(aimTemplateAims.get(i).getPower());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

